(function() {
	window.H5lock = function(obj) {
		this.height = obj.height;
		this.width = obj.width;
		var state = app.getState();
		this.chooseType = Number(window.localStorage.getItem('chooseType'+state.account)) || obj.chooseType;
	};
	
	H5lock.prototype.drawCle = function(x, y) { // 初始化解锁密码面板
		this.ctx.strokeStyle = '#CFE6FF';
		this.ctx.lineWidth = 2;
		this.ctx.beginPath();
		this.ctx.arc(x, y, this.r, 0, Math.PI * 2, true);
		this.ctx.closePath();
		this.ctx.stroke();
	}
	H5lock.prototype.drawPoint = function() { // 初始化圆心
		for (var i = 0; i < this.lastPoint.length; i++) {
			this.ctx.fillStyle = '#CFE6FF';
			this.ctx.beginPath();
			this.ctx.arc(this.lastPoint[i].x, this.lastPoint[i].y, this.r / 2, 0, Math.PI * 2, true);
			this.ctx.closePath();
			this.ctx.fill();
		}
	}
	H5lock.prototype.drawStatusPoint = function(type) { // 初始化状态线条
		for (var i = 0; i < this.lastPoint.length; i++) {
			this.ctx.strokeStyle = type;
			this.ctx.beginPath();
			this.ctx.arc(this.lastPoint[i].x, this.lastPoint[i].y, this.r, 0, Math.PI * 2, true);
			this.ctx.closePath();
			this.ctx.stroke();
		}
	}
	H5lock.prototype.drawLine = function(po, lastPoint) { // 解锁轨迹
		this.ctx.beginPath();
		this.ctx.lineWidth = 3;
		this.ctx.moveTo(this.lastPoint[0].x, this.lastPoint[0].y);
		console.log(this.lastPoint.length);
		for (var i = 1; i < this.lastPoint.length; i++) {
			this.ctx.lineTo(this.lastPoint[i].x, this.lastPoint[i].y);
		}
		this.ctx.lineTo(po.x, po.y);
		this.ctx.stroke();
		this.ctx.closePath();

	}
	H5lock.prototype.createCircle = function() { // 创建解锁点的坐标，根据canvas的大小来平均分配半径

		var n = this.chooseType;
		var count = 0;
		this.r = this.ctx.canvas.width / (2 + 4 * n); // 公式计算
		this.lastPoint = [];
		this.arr = [];
		this.restPoint = [];
		var r = this.r;
		for (var i = 0; i < n; i++) {
			for (var j = 0; j < n; j++) {
				count++;
				var obj = {
					x: j * 4 * r + 3 * r,
					y: i * 4 * r + 3 * r,
					index: count
				};
				this.arr.push(obj);
				this.restPoint.push(obj);
			}
		}
		this.ctx.clearRect(0, 0, this.ctx.canvas.width, this.ctx.canvas.height);
		for (var i = 0; i < this.arr.length; i++) {
			this.drawCle(this.arr[i].x, this.arr[i].y);
		}
		//return arr;
	}
	H5lock.prototype.getPosition = function(e) { // 获取touch点相对于canvas的坐标
		var rect = e.currentTarget.getBoundingClientRect();
		var po = {
			x: e.touches[0].clientX - rect.left,
			y: e.touches[0].clientY - rect.top
		};
		return po;
	}
	H5lock.prototype.update = function(po) { // 核心变换方法在touchmove时候调用
		this.ctx.clearRect(0, 0, this.ctx.canvas.width, this.ctx.canvas.height);

		for (var i = 0; i < this.arr.length; i++) { // 每帧先把面板画出来
			this.drawCle(this.arr[i].x, this.arr[i].y);
		}

		this.drawPoint(this.lastPoint); // 每帧花轨迹
		this.drawLine(po, this.lastPoint); // 每帧画圆心

		for (var i = 0; i < this.restPoint.length; i++) {
			if (Math.abs(po.x - this.restPoint[i].x) < this.r && Math.abs(po.y - this.restPoint[i].y) < this.r) {
				this.drawPoint(this.restPoint[i].x, this.restPoint[i].y);
				this.lastPoint.push(this.restPoint[i]);
				this.restPoint.splice(i, 1);
				break;
			}
		}

	}
	H5lock.prototype.checkPass = function(psw1, psw2) { // 检测密码
		var p1 = '',
			p2 = '';
		for (var i = 0; i < psw1.length; i++) {
			p1 += psw1[i].index + psw1[i].index;
		}
		for (var i = 0; i < psw2.length; i++) {
			p2 += psw2[i].index + psw2[i].index;
		}
		return p1 === p2;
	}
	H5lock.prototype.storePass = function(psw) { // touchend结束之后对密码和状态的处理
		if (this.pswObj.step == 1) {
			if (this.checkPass(this.pswObj.fpassword, psw)) {
				this.pswObj.step = 2;
				this.pswObj.spassword = psw;
				document.getElementById('title').innerHTML = i18next.t('systemset.keepPas');
				this.drawStatusPoint('#2CFF26');
				var state = app.getState();
				window.localStorage.setItem('passwordxx'+state.account, JSON.stringify(this.pswObj.spassword));
				window.localStorage.setItem('chooseType'+state.account, this.chooseType);
				/* 重置密码操作 */
				mui.back()
				/* 结束 */
			} else {
				document.getElementById('title').innerHTML = i18next.t('systemset.againPas');
				this.drawStatusPoint('red');
				delete this.pswObj.step;
			}
		} else if (this.pswObj.step == 2) {
			if (this.checkPass(this.pswObj.spassword, psw)) {
				document.getElementById('title').innerHTML = i18next.t('systemset.lockSucc');
				this.drawStatusPoint('#2CFF26');
				/* 登录解锁操作 */
			  var showtype=localStorage.getItem('H5showType');
			  if(showtype=='login'){
				  window.localStorage.setItem('H5lockshow', 'false');
				  var data = localStorage.getItem("logininfo");
				  var dataObj = JSON.parse(data);
				  	var loginInfo = {
				  		account: dataObj.data.account,
				  		password: dataObj.data.password
				  	};
				  	console.log(JSON.stringify(loginInfo))
						//不管是正确还是错误,都进行登录,原因是正确即登录账号更新账号信息,错误登录则为离线模式,使用的是缓存信息
				  	app.login(loginInfo, function(err) {
				  		if (err) {
				  			console.log(JSON.stringify(err))
							var mainPage = mui.openWindow({
								url: 'tab-webview-main.html',
								id: 'main',
								styles: {
									popGesture: "none",
									render: "always",
									statusbar: {
										background: "#27282a"
									}
								},
								show: {
									aniShow: 'none'
								},
								waiting: {
									autoShow: false
								}
							});
							console.log("登录刷新车辆列表")
							// 刷新车辆列表
							var vehiclePage = plus.webview.getWebviewById('vehicle-list');
							mui.fire(vehiclePage, 'refreshVehicle', null);
							var mainPage = plus.webview.getWebviewById('main');
							
							mui.fire(mainPage, 'show', null);
							mainPage.show("pop-in");
							var ws = plus.webview.currentWebview();
							 plus.webview.close(ws);
				  		} else {
				  			var mainPage = mui.openWindow({
				  				url: 'tab-webview-main.html',
				  				id: 'main',
				  				styles: {
				  					popGesture: "none",
				  					render: "always",
				  					statusbar: {
				  						background: "#27282a"
				  					}
				  				},
				  				show: {
				  					aniShow: 'none'
				  				},
				  				waiting: {
				  					autoShow: false
				  				}
				  			});
				  			console.log("登录刷新车辆列表")
				  			// 刷新车辆列表
				  			var vehiclePage = plus.webview.getWebviewById('vehicle-list');
				  			mui.fire(vehiclePage, 'refreshVehicle', null);
				  			var mainPage = plus.webview.getWebviewById('main');
				  			
				  			mui.fire(mainPage, 'show', null);
				  			mainPage.show("pop-in");
							var ws = plus.webview.currentWebview();
							 plus.webview.close(ws);
				  		}
				  	});
			  }
				/* 结束 */
			} else {

				this.drawStatusPoint('red');
				document.getElementById('title').innerHTML = i18next.t('systemset.lockFail');
				var state = app.getState();
				var aa = localStorage.getItem('passwordxx'+state.account)
				console.log(aa)
			}
		} else {
			this.pswObj.step = 1;
			this.pswObj.fpassword = psw;
			document.getElementById('title').innerHTML = i18next.t('systemset.againIpu');
		}

	}
	H5lock.prototype.makeState = function() {
		console.log("H5lock显示")
		var showtype=localStorage.getItem('H5showType');
		console.log(showtype)
		console.log(this.pswObj.step)
		if (this.pswObj.step == 2) {
			document.getElementById('updatePassword').style.display = 'block';
			//document.getElementById('chooseType').style.display = 'none';
			document.getElementById('title').innerHTML = i18next.t('systemset.plsLock');
		} else if (this.pswObj.step == 1) {
			//document.getElementById('chooseType').style.display = 'none';
			document.getElementById('updatePassword').style.display = 'none';
		} else {
			document.getElementById('updatePassword').style.display = 'none';
			//document.getElementById('chooseType').style.display = 'block';
		}
		if(showtype=='set'){
			document.getElementById('reback').style.display = 'block';
		}else{
			document.getElementById('reback').style.display = 'none';
			document.getElementById('updatePassword').style.display = 'none';
			document.getElementById('forGetPsw').style.display = 'block';
		}
	}
	H5lock.prototype.setChooseType = function(type) {
		chooseType = type;
		init();
	}
	H5lock.prototype.updatePassword = function() {
		window.localStorage.removeItem('passwordxx');
		window.localStorage.removeItem('chooseType');
		this.pswObj = {};
		document.getElementById('title').innerHTML = i18next.t('systemset.draw');
		this.reset();
	}
	H5lock.prototype.initDom = function() {
		var wrap = document.createElement('div');
		var str =
			// '<a id="reback" class="mui-action-back mui-icon mui-icon-left-nav mui-pull-left" style="display:none;"></a>' +
			// '<h4 id="title" class="title">'+i18next.t('systemset.draw')+'</h4>' +
			// '<a id="updatePassword" style="position: absolute;right: 5px;top: 5px;color:#fff;font-size: 14px;display:none;">'+i18next.t('systemset.resetPas')+'</a>'+
			// '<a id="forGetPsw" style="position: absolute;right: 5px;top: 5px;color:#fff;font-size: 14px;display:none;">'+i18next.t('systemset.forgetPas')+'</a>' +
			'<canvas id="canvas" width="300" height="300" style="display:flex;justify-content: center;align-items:center;"></canvas>';
		wrap.setAttribute('style', 'position: absolute;top:0;left:0;right:0;bottom:0;');
		wrap.innerHTML = str;
		document.body.appendChild(wrap);
	}
	H5lock.prototype.init = function() {
		// console.log("99999999999999999999")
		// this.initDom();
		var state = app.getState();
		this.pswObj = window.localStorage.getItem('passwordxx'+state.account) ? {
			step: 2,
			spassword: JSON.parse(window.localStorage.getItem('passwordxx'+state.account))
		} : {};
		this.lastPoint = [];
		this.makeState();
		this.touchFlag = false;
		this.canvas = document.getElementById('canvas');
		this.ctx = this.canvas.getContext('2d');
		this.createCircle();
		this.bindEvent();
	}
	H5lock.prototype.reset = function() {
		this.makeState();
		this.createCircle();
	}
	H5lock.prototype.bindEvent = function() {
		var self = this;
		this.canvas.addEventListener("touchstart", function(e) {
			e.preventDefault(); // 某些android 的 touchmove不宜触发 所以增加此行代码
			var po = self.getPosition(e);
			console.log(po);
			for (var i = 0; i < self.arr.length; i++) {
				if (Math.abs(po.x - self.arr[i].x) < self.r && Math.abs(po.y - self.arr[i].y) < self.r) {

					self.touchFlag = true;
					self.drawPoint(self.arr[i].x, self.arr[i].y);
					self.lastPoint.push(self.arr[i]);
					self.restPoint.splice(i, 1);
					break;
				}
			}
		}, false);
		this.canvas.addEventListener("touchmove", function(e) {
			if (self.touchFlag) {
				self.update(self.getPosition(e));
			}
		}, false);
		this.canvas.addEventListener("touchend", function(e) {
			if (self.touchFlag) {
				self.touchFlag = false;
				self.storePass(self.lastPoint);
				setTimeout(function() {

					self.reset();
				}, 300);
			}


		}, false);
		document.addEventListener('touchmove', function(e) {
			e.preventDefault();
		}, false);
		document.getElementById('forGetPsw').addEventListener('click', function() {
			/* 忘记密码登录 */
			//判断密码是否正确 如果正确则带着缓存账号密码 登录
				var btnArray = [i18next.t('systemset.confirm'), i18next.t('systemset.cancel')];
				mui.prompt(' ', i18next.t('systemset.inputPas'), i18next.t('systemset.forgetDraw'), btnArray, function(e) {
					if (e.index == 1) {
						// console.log("取消")
					} else {
						// console.log("确定")
						// console.log(e.value)
						var data = localStorage.getItem("logininfo");
						var dataObj = JSON.parse(data);
						console.log(e.value==dataObj.data.password)
						if(e.value==dataObj.data.password){
							//登录
							var loginInfo = {
								account: dataObj.data.account,
								password: e.value
							};
							console.log(JSON.stringify(loginInfo))
							//不管是正确还是错误,都进行登录,原因是正确即登录该账号,错误则使用的为离线状态
							app.login(loginInfo, function(err) {
								if (err) {
									console.log(JSON.stringify(err))
									var mainPage = mui.openWindow({
										url: 'tab-webview-main.html',
										id: 'main',
										styles: {
											popGesture: "none",
											render: "always",
											statusbar: {
												background: "#27282a"
											}
										},
										show: {
											aniShow: 'none'
										},
										waiting: {
											autoShow: false
										}
									});
									console.log("登录刷新车辆列表")
									// 刷新车辆列表
									var vehiclePage = plus.webview.getWebviewById('vehicle-list');
									mui.fire(vehiclePage, 'refreshVehicle', null);
									var mainPage = plus.webview.getWebviewById('main');
									
									mui.fire(mainPage, 'show', null);
									mainPage.show("pop-in");
								} else {
									var mainPage = mui.openWindow({
										url: 'tab-webview-main.html',
										id: 'main',
										styles: {
											popGesture: "none",
											render: "always",
											statusbar: {
												background: "#27282a"
											}
										},
										show: {
											aniShow: 'none'
										},
										waiting: {
											autoShow: false
										}
									});
									console.log("登录刷新车辆列表")
									// 刷新车辆列表
									var vehiclePage = plus.webview.getWebviewById('vehicle-list');
									mui.fire(vehiclePage, 'refreshVehicle', null);
									var mainPage = plus.webview.getWebviewById('main');
									
									mui.fire(mainPage, 'show', null);
									mainPage.show("pop-in");
								}
							});
						}else{
							//跳转至login
							app.toast(i18next.t('systemset.pasError'))
						}
						
					}
				})
			/* 结束 */
		})
		document.getElementById('updatePassword').addEventListener('click', function() {
			/* 重置手势密码 */
			//先弹出进行密码验证
			var btnArray = [i18next.t('systemset.confirm'), i18next.t('systemset.cancel')];
			mui.prompt(' ', i18next.t('systemset.inputPas'), i18next.t('systemset.verification'), btnArray, function(e) {
				if (e.index == 1) {
				} else {
					 console.log("确定")
					 var state = app.getState();
					 console.log(JSON.stringify(state))
					 if(hex_md5(e.value)==state.password){
						  self.updatePassword();
					 }else{
						 app.toast(i18next.t('systemset.pasError'))
					 }
				}
			})
			// console.log("点击重置密码")
			//
			/* 结束 */
			
		
		
		});
	}
})();
